use lib "$ENV{'PERF_EXEC_PATH'}/scripts/perl/Perf-Trace-Util/lib";
use lib "./Perf-Trace-Util/lib";
use Perf::Trace::Core;
use Perf::Trace::Context;
use Perf::Trace::Util;

@count = ();
$current_id = -1;

sub trace_end
{
	for ($id = 0; $id < 1024; $id++) {
		if (@count[$id] != 0) {
			printf("syscall %d invokes kmalloc %d times.\n",
				$id, @count[$id]);
		}
	}
}

sub raw_syscalls::sys_enter
{
	my ($event_name, $context, $common_cpu, $common_secs, $common_nsecs,
	    $common_pid, $common_comm,
	    $id, $args) = @_;

	$current_id = $id;
}

sub kmem::kmalloc
{
	my ($event_name, $context, $common_cpu, $common_secs, $common_nsecs,
	    $common_pid, $common_comm,
	    $call_site, $ptr, $bytes_req, $bytes_alloc, 
	    $gfp_flags) = @_;

	if ($current_id != -1) {
		@count[$current_id]++;
	}
}
